/*
 * Internal Utility API
 * This API allows you to access internal data.
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package org.wso2.am.integration.clients.internal.api.dto;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * RevokedJWTSubjectEntityDTO
 */

public class RevokedJWTSubjectEntityDTO {
  @SerializedName("entity_id")
  private String entityId = null;

  @SerializedName("entity_type")
  private String entityType = null;

  @SerializedName("revocation_time")
  private Long revocationTime = null;

  @SerializedName("organization")
  private String organization = null;

  public RevokedJWTSubjectEntityDTO entityId(String entityId) {
    this.entityId = entityId;
    return this;
  }

   /**
   * Subject Id of the revoked JWT(s). Can be user id or client id.
   * @return entityId
  **/
  @ApiModelProperty(value = "Subject Id of the revoked JWT(s). Can be user id or client id.")
  public String getEntityId() {
    return entityId;
  }

  public void setEntityId(String entityId) {
    this.entityId = entityId;
  }

  public RevokedJWTSubjectEntityDTO entityType(String entityType) {
    this.entityType = entityType;
    return this;
  }

   /**
   * Type of the subject id. User id or client id.
   * @return entityType
  **/
  @ApiModelProperty(value = "Type of the subject id. User id or client id.")
  public String getEntityType() {
    return entityType;
  }

  public void setEntityType(String entityType) {
    this.entityType = entityType;
  }

  public RevokedJWTSubjectEntityDTO revocationTime(Long revocationTime) {
    this.revocationTime = revocationTime;
    return this;
  }

   /**
   * revocation timestamp.
   * @return revocationTime
  **/
  @ApiModelProperty(value = "revocation timestamp.")
  public Long getRevocationTime() {
    return revocationTime;
  }

  public void setRevocationTime(Long revocationTime) {
    this.revocationTime = revocationTime;
  }

  public RevokedJWTSubjectEntityDTO organization(String organization) {
    this.organization = organization;
    return this;
  }

   /**
   * Organization of the revoked subject entity.
   * @return organization
  **/
  @ApiModelProperty(value = "Organization of the revoked subject entity.")
  public String getOrganization() {
    return organization;
  }

  public void setOrganization(String organization) {
    this.organization = organization;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    RevokedJWTSubjectEntityDTO revokedJWTSubjectEntity = (RevokedJWTSubjectEntityDTO) o;
    return Objects.equals(this.entityId, revokedJWTSubjectEntity.entityId) &&
        Objects.equals(this.entityType, revokedJWTSubjectEntity.entityType) &&
        Objects.equals(this.revocationTime, revokedJWTSubjectEntity.revocationTime) &&
        Objects.equals(this.organization, revokedJWTSubjectEntity.organization);
  }

  @Override
  public int hashCode() {
    return Objects.hash(entityId, entityType, revocationTime, organization);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class RevokedJWTSubjectEntityDTO {\n");
    
    sb.append("    entityId: ").append(toIndentedString(entityId)).append("\n");
    sb.append("    entityType: ").append(toIndentedString(entityType)).append("\n");
    sb.append("    revocationTime: ").append(toIndentedString(revocationTime)).append("\n");
    sb.append("    organization: ").append(toIndentedString(organization)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

